<?php

namespace Cli\Assets;

trait Console
{

    /**
     * @var false|resource
     */
    private $handle = false;

    /**
     * @param string $message
     */
    public function print(string $message, $color = null, $background = '')
    {
        echo Colors::getColoredString($message, $color, $background);
    }

    /**
     * @param string $message
     */
    public function printLn(string $message, $color = null, $background = '')
    {
        $this->print($message, $color, $background);
        echo "\n";
    }

    /**
     * @param string $message
     */
    public function success(string $message)
    {
        $this->printLn($message, 'green');
    }

    /**
     * @param $question
     * @return string
     */
    public function ask($question)
    {
        $this->success($question);
        $this->print("\n  >  ", 'yellow');

        return $this->getLine();
    }

    /**
     * Terminate console
     */
    public function terminate()
    {
        exit(0);
    }

    /**
     * @return string
     */
    private function getLine()
    {
        if( $this->handle === false) {
            $this->handle = fopen("php://stdin","r");
        }

        return trim(fgets($this->handle));
    }

}